diff --git a/premake5.lua b/premake5.lua
index 37c50fca8..990df76ab 100644
--- a/premake5.lua
+++ b/premake5.lua
@@ -580,6 +580,7 @@ elseif (os.istarget("linux")) then
     files
     {
         "vst3sdk/public.sdk/source/main/linuxmain.cpp",
+	"src/linux/LinuxVST3Helpers.cpp"
     }
 
     excludes {
diff --git a/src/common/SurgeStorage.cpp b/src/common/SurgeStorage.cpp
index 6653465f1..7c756191a 100644
--- a/src/common/SurgeStorage.cpp
+++ b/src/common/SurgeStorage.cpp
@@ -39,7 +39,7 @@ float table_dB alignas(16)[512],
       table_envrate_lpf alignas(16)[512],
       table_envrate_linear alignas(16)[512];
 float waveshapers alignas(16)[8][1024];
-float samplerate, samplerate_inv;
+float samplerate = 0, samplerate_inv;
 double dsamplerate, dsamplerate_inv;
 double dsamplerate_os, dsamplerate_os_inv;
 
diff --git a/src/common/gui/SurgeGUIEditor.cpp b/src/common/gui/SurgeGUIEditor.cpp
index 04711ba09..7848df023 100644
--- a/src/common/gui/SurgeGUIEditor.cpp
+++ b/src/common/gui/SurgeGUIEditor.cpp
@@ -32,6 +32,8 @@
 #include "aulayer.h"
 #endif
 
+#include "vstgui/lib/platform/platform_x11.h"
+#include "vstgui/lib/platform/linux/x11platform.h"
 
 #include "RuntimeFont.h"
 
@@ -1320,12 +1322,28 @@ void SurgeGUIEditor::close_editor()
    setzero(param);
 }
 
+#if LINUX && TARGET_VST3
+extern void LinuxVST3Init(Steinberg::Linux::IRunLoop* pf);
+extern void LinuxVST3FrameOpen(CFrame* that, void*, const VSTGUI::PlatformType& pt);
+#endif
+
 #if !TARGET_VST3
 bool SurgeGUIEditor::open(void* parent)
 #else
 bool PLUGIN_API SurgeGUIEditor::open(void* parent, const PlatformType& platformType)
 #endif
 {
+   if (samplerate == 0)
+   {
+      std::cout << "SampleRate never set when editor opened. Setting to 44.1k" << std::endl;
+
+      /*
+      ** The oscillator displays need a sample rate; some test hosts don't call
+      ** setSampleRate so if we are in this state make the bad but reasonable
+      ** default choice
+      */
+      synth->setSamplerate(44100);
+   }
 #if !TARGET_VST3
    // !!! always call this !!!
    super::open(parent);
@@ -1334,6 +1352,23 @@ bool PLUGIN_API SurgeGUIEditor::open(void* parent, const PlatformType& platformT
 #endif
 
 #if TARGET_VST3
+#if LINUX
+   Steinberg::Linux::IRunLoop* l = nullptr;
+   if (getIPlugFrame()->queryInterface(Steinberg::Linux::IRunLoop::iid, (void**)&l) ==
+       Steinberg::kResultOk)
+   {
+      std::cout << "IPlugFrame is a runloop " << l << std::endl;
+   }
+   else
+   {
+      std::cout << "IPlogFrame is not a runloop " << l << std::endl;
+   }
+   if (l == nullptr)
+   {
+      Surge::UserInteractions::promptError("Starting VST3 with null runloop", "Software Error");
+   }
+   LinuxVST3Init(l);
+#endif
    _idleTimer->start();
 #endif
 
@@ -1355,7 +1390,11 @@ bool PLUGIN_API SurgeGUIEditor::open(void* parent, const PlatformType& platformT
    nframe->setBackground(cbm);
 
    frame = nframe;
+#if LINUX && TARGET_VST3
+   LinuxVST3FrameOpen(frame, parent, platformType);
+#else
    frame->open(parent, platformType);
+#endif
    /*#if TARGET_AUDIOUNIT
            synth = (sub3_synth*)_effect;
    #elif TARGET_VST3
diff --git a/src/linux/LinuxVST3Helpers.cpp b/src/linux/LinuxVST3Helpers.cpp
new file mode 100644
index 000000000..a854cc379
--- /dev/null
+++ b/src/linux/LinuxVST3Helpers.cpp
@@ -0,0 +1,220 @@
+/*
+** The various things we need to help with VST3 Linux
+*/
+
+#include <iostream>
+#include <pthread.h>
+#include <unistd.h>
+#include "public.sdk/source/vst/vstguieditor.h"
+#include "vstgui/lib/platform/platform_x11.h"
+#include "vstgui/lib/platform/linux/x11platform.h"
+#include "base/source/updatehandler.h"
+
+using namespace VSTGUI;
+
+// Map Steinberg Vst Interface (Steinberg::Linux::IRunLoop) to VSTGUI Interface
+// (VSTGUI::X11::RunLoop)
+class RunLoop : public X11::IRunLoop, public AtomicReferenceCounted
+{
+public:
+   struct EventHandler : Steinberg::Linux::IEventHandler, public Steinberg::FObject
+   {
+      X11::IEventHandler* handler{nullptr};
+
+      void PLUGIN_API onFDIsSet(Steinberg::Linux::FileDescriptor) override
+      {
+         // std::cout << __func__ << " " << handler << std::endl;
+         if (handler)
+            handler->onEvent();
+         // std::cout << __func__ << " END " << handler << std::endl;
+      }
+      DELEGATE_REFCOUNT(Steinberg::FObject)
+      DEFINE_INTERFACES
+      DEF_INTERFACE(Steinberg::Linux::IEventHandler)
+      END_DEFINE_INTERFACES(Steinberg::FObject)
+   };
+
+   struct TimerHandler : Steinberg::Linux::ITimerHandler, public Steinberg::FObject
+   {
+      X11::ITimerHandler* handler{nullptr};
+
+      void PLUGIN_API onTimer() final
+      {
+         // std::cout << __func__ << " " << handler << std::endl;
+         if (handler)
+            handler->onTimer();
+         // std::cout << __func__ << " END " << handler << std::endl;
+      }
+      DELEGATE_REFCOUNT(Steinberg::FObject)
+      DEFINE_INTERFACES
+      DEF_INTERFACE(Steinberg::Linux::ITimerHandler)
+      END_DEFINE_INTERFACES(Steinberg::FObject)
+   };
+
+   bool registerEventHandler(int fd, X11::IEventHandler* handler) final
+   {
+      std::cout << __func__ << " " << fd << " " << handler << std::endl;
+      if (!runLoop)
+         return false;
+
+      auto smtgHandler = Steinberg::owned(new EventHandler());
+      smtgHandler->handler = handler;
+      if (runLoop->registerEventHandler(smtgHandler, fd) == Steinberg::kResultTrue)
+      {
+         eventHandlers.push_back(smtgHandler);
+         return true;
+      }
+      return false;
+   }
+
+   bool unregisterEventHandler(X11::IEventHandler* handler) final
+   {
+      std::cout << __func__ << " " << handler << std::endl;
+      if (!runLoop)
+         return false;
+
+      for (auto it = eventHandlers.begin(), end = eventHandlers.end(); it != end; ++it)
+      {
+         if ((*it)->handler == handler)
+         {
+            runLoop->unregisterEventHandler((*it));
+            eventHandlers.erase(it);
+            return true;
+         }
+      }
+      return false;
+   }
+   bool registerTimer(uint64_t interval, X11::ITimerHandler* handler) final
+   {
+      std::cout << __func__ << " " << interval << " " << handler << std::endl;
+      if (!runLoop)
+         return false;
+      std::cout << "Have a runloop" << std::endl;
+
+      auto smtgHandler = Steinberg::owned(new TimerHandler());
+      smtgHandler->handler = handler;
+      if (runLoop->registerTimer(smtgHandler, interval) == Steinberg::kResultTrue)
+      {
+         timerHandlers.push_back(smtgHandler);
+         return true;
+      }
+      return false;
+   }
+   bool unregisterTimer(X11::ITimerHandler* handler) final
+   {
+      std::cout << __func__ << " " << handler << std::endl;
+      if (!runLoop)
+         return false;
+
+      for (auto it = timerHandlers.begin(), end = timerHandlers.end(); it != end; ++it)
+      {
+         if ((*it)->handler == handler)
+         {
+            runLoop->unregisterTimer((*it));
+            timerHandlers.erase(it);
+            return true;
+         }
+      }
+      return false;
+   }
+
+   RunLoop(Steinberg::Linux::IRunLoop* _runLoop) : runLoop(_runLoop)
+   {
+      std::cout << "RunLoop is " << runLoop << " " << _runLoop << std::endl;
+   }
+
+private:
+   using EventHandlers = std::vector<Steinberg::IPtr<EventHandler>>;
+   using TimerHandlers = std::vector<Steinberg::IPtr<TimerHandler>>;
+   EventHandlers eventHandlers;
+   TimerHandlers timerHandlers;
+   // Steinberg::FUnknownPtr<Steinberg::Linux::IRunLoop> runLoop;
+   Steinberg::Linux::IRunLoop* runLoop;
+};
+
+//-----------------------------------------------------------------------------
+class UpdateHandlerInit
+{
+public:
+   UpdateHandlerInit()
+   {
+      get();
+   }
+   Steinberg::UpdateHandler* get()
+   {
+      return Steinberg::UpdateHandler::instance();
+   }
+};
+
+static UpdateHandlerInit gUpdateHandlerInit;
+
+//-----------------------------------------------------------------------------
+class IdleUpdateHandler
+{
+public:
+   static void start()
+   {
+      auto& instance = get();
+      if (++instance.users == 1)
+      {
+         /*
+         instance.timer = VSTGUI::makeOwned<VSTGUI::CVSTGUITimer>
+           (
+            [] (VSTGUI::CVSTGUITimer*) {
+              std::cout << "DEFUP" << std::endl;
+              gUpdateHandlerInit.get ()->triggerDeferedUpdates (); },
+            1000 / 30);
+         */
+         pthread_t t;
+         pthread_create(&t, NULL, IdleUpdateHandler::doDefUp, NULL);
+      }
+   }
+
+   static void* doDefUp(void* x)
+   {
+      while (true)
+      {
+         // std::cout << "GUpdate" << std::endl;
+         gUpdateHandlerInit.get()->triggerDeferedUpdates();
+         usleep(1000 / 30.0);
+      }
+   }
+
+   static void stop()
+   {
+      auto& instance = get();
+      if (--instance.users == 0)
+      {
+         instance.timer = nullptr;
+      }
+   }
+
+protected:
+   static IdleUpdateHandler& get()
+   {
+      static IdleUpdateHandler gInstance;
+      return gInstance;
+   }
+
+   VSTGUI::SharedPointer<VSTGUI::CVSTGUITimer> timer;
+   std::atomic<uint32_t> users{0};
+};
+
+void LinuxVST3Init(Steinberg::Linux::IRunLoop* rl)
+{
+   std::cout << "irl is " << rl << std::endl;
+   VSTGUI::X11::RunLoop::init(owned(new RunLoop(rl)));
+}
+
+void LinuxVST3FrameOpen(VSTGUI::CFrame* that, void* parent, const VSTGUI::PlatformType& pt)
+{
+   IPlatformFrameConfig* config = nullptr;
+   X11::FrameConfig x11config;
+   x11config.runLoop = VSTGUI::X11::RunLoop::get();
+   config = &x11config;
+
+   std::cout << "Special Magical VST3 Open" << std::endl;
+   that->open(parent, pt, config);
+
+   IdleUpdateHandler::start();
+}
